client
	North()
	South()
	East()
	West()
	Northeast()
	Southeast()
	Northwest()
	Southwest()
world

	proc/move()
		spawn()
			while(1)
				for(var/client/c in clients)
					c.mob && c.mob.move()

				sleep(tick_lag)


turf/var/ground_friction=1

mob
	proc
		move()
		getSpeed()
		/*	if(istype(src,/mob/player))
				if(length(src:carried_objects))
					var/obj/O = src:carried_objects[1]
					if(O)
						return 2/O.weight*/
			return 2

	player
		standing=1

		var
			tmp/walk_counter=0
			tmp/walk_frame=1
			tmp/can_dust=1
			tmp/last_mx=0
			tmp/last_my=0
			tmp/friction=1.4
			tmp/moving=0
			tmp/slowed=0
			tmp/attacking=0

		proc
			friction()
				var/turf/T = loc
				if(T)
					return friction+T.ground_friction

			my_idle()
				return ""

		move()

			onTick()
			moving=0

			if(!dead && !in_dialogue)

				moving=1

				var/F = max(abs(client.move_analog_x),abs(client.move_analog_y))

				var speed = getSpeed()*(slowed > world.time ? 0.5 : 1)

			/*	if(length(src:carried_objects))
					var/obj/O = src:carried_objects[1]
					if(O && O.weight < 1)
						speed = speed*O.weight*/

				if(speed && (client.move_analog_x || client.move_analog_y) && (client.gamepad ? 1 : !showingHud("grid manager")))

					if(F > 0.01)

						dir = analog2dir(client.move_analog_x,client.move_analog_y)


						var/Tx = Cx()
						var/Ty = Cy()
						var/YY = client.move_analog_y * speed


						Translate(client.move_analog_x * speed,YY)

						if(Cx() == Tx && Cy() == Ty)
							Translate(client.move_analog_x * speed,0)
							if(Cx() == Tx && Cy() == Ty)
								Translate(0,YY)

						last_mx = client.move_analog_x*speed
						last_my = YY

					//	animate(client,pixel_y=client.move_analog_y*10,pixel_x = client.move_analog_x*10,time=2)

						update_layer()



						walk_counter += F

						if(walk_counter > 4)
							walk_counter = 0

							footstep(20,"walk [walk_frame]")


							walk_frame++

							if(walk_frame % 2 ==0)
								dust()
							if(walk_frame > 4)
								walk_frame = 1

						icon_state = "walk [walk_frame]"


					else if(!attacking)
						icon_state = "[my_idle()]"

						if(last_mx > 0.01 || last_my > 0.01)
							last_mx = last_mx/friction()
							last_my = last_my/friction()
							Translate(last_mx,last_my)

				else if(!attacking)
					icon_state = "[my_idle()]"

					if(last_mx > 0.01 || last_my > 0.01)
						last_mx = last_mx/friction()
						last_my = last_my/friction()
						Translate(last_mx,last_my)

