atom/movable/proc/projectile_crossed()

atom/movable/Cross(obj/projectile/p)
	if(istype(p))
		projectile_crossed(p)

		if(src in p.cant_collide)
			return TRUE

		if(p.owner==src)

			return TRUE

		if(istype(src,/mob/player) && (src:dead))
			return TRUE


	return ..()

mob
	player
		proc

			Shoot(t,Angle,obj/o)
				if(istype(src,/mob/player) && src:dead)
					return
				var/X = text2path("/obj/projectile/[t]")
				if(X)
					new X (src, Angle,o ? o : null,null)
obj
	proc

		Shoot(t,Angle,obj/o)
			var/X = text2path("/obj/projectile/[t]")
			if(X)
				new X (src, Angle,o ? o : null,null)

mob/player/var/dead=0

atom/movable

	var/tmp/hit_walls=1
	var/tmp/only_cross
	var/tmp/player_proj=0


	proc/sparkle()
		var/obj/o = new/obj
		o.icon = 'effects.dmi'
		o.icon_state = "spark"
		o.pewt = 2
		o.pixel_y = pixel_y
		o.pixel_x = pixel_x
		o.SetCenter(Cx(),Cy(),z)
		o.spawndel(5)
		o.pewt()
		o.invisibility=3
obj



	projectile

	//	bounds = "5,5 to 12,12"

		density = TRUE
		icon = 'effects.dmi'

		var only_players = FALSE
		var densenotime = FALSE

		var floats
		var last_angle
		var angle = 0
		var vel_x = 0
		var vel_y = 0

		proc/hit_owner()
		proc/has_fire()
			return 0
		var speed = 8

		var iterations
		var max_iterations = 20

		var delay = null
		var instant = FALSE

		var stuck_icon

		var mob/player/owner
		var mob/lasthit
		var damage = 0
		var can_hit = TRUE


		var atom/movable/pos_owner

		var or_angle
		var time = 10

		var damage_mtype=null
		var damage_mtype2=null
		layer = MOB_LAYER+1
		var/item/equipment/item_owner

		New(mob/m, angle, obj/o,item/i)
			..()
			m.contents -= src
			if(!delay)
				delay = world.tick_lag

			owner = m

			pos_owner = o ? o : m
			luminosity=2
			reposition(o)

			setAngle(angle)
			or_angle = angle
			setOffset(angle)

			do_shit()

			spawn(time)
				if(spawndels)
					del src
		var/tmp/spawndels=1
		proc/setOffset(a)
			if(start_offset)
				Translate(cos(a+start_offset_a)*start_offset,sin(a+start_offset_a)*start_offset)
		var/tmp
			start_offset=0
			start_offset_a=0
		Del()
			if(pewt)
				pewt()
			owner=null
			pos_owner=null
			lasthit=null
			loc=null
			..()


		Bump(atom/m)
			..(m)
			if(ismob(m))
				if(m != owner && m && owner && !(m in cant_collide))
					onHit(m)
				if(!owner)
					onHit(m)

			else if(m != pos_owner)
				if(!istype(m, /obj/projectile))
					wall_hit()
				else
					if(m:owner != owner)
						del(m)
						del(src)


		has_fire()
			return 0
		Cross(atom/o)
			if(istype(o, /obj/projectile/) && o:owner != owner)
				return TRUE


			if(o == owner) return TRUE

			if(o in cant_collide) return TRUE

			return ..()


		proc/do_shit()
			if(!src.loc)
				return

			if(angle != last_angle)
				setAngle(angle)

			Translate(vel_x, vel_y)

			if(instant)
				iterations ++
				if(iterations == max_iterations && spawndels)
					del src
				else
					do_shit()

			else
				spawn(delay)
					do_shit()

		proc/projectileCollide(obj/projectile/m)
			return TRUE

		var/damage_percent=1
		var/deletesonhit=1
		var/damage_type

		proc/onKill(mob/player/m)
		proc/getDamage()
			return damage
		var/poisedmg=1

		proc/onHit(mob/player/m)
			lasthit = m

			if(!owner)
				lasthit=null
				return
			if(getDamage())


				m.damage(getDamage(),ismob(owner) ? owner : null)

				if(!m || m.dead)
					onKill(m)



			if(deletesonhit)
				del src
			else
				cant_collide += m

		var/cant_collide = list()
		var/ability/ability_owner
		proc/reposition()
			dir = pos_owner.dir
			SetCenter(pos_owner.Cx(), pos_owner.Cy(), pos_owner.z)

		var/vangle=0
		proc/setAngle(new_angle)
			angle = new_angle
			last_angle = angle

			if(rotates)
				var matrix/M = matrix()
				transform = turn(M, vangle ? vangle : new_angle)
			getVelocity()

		var/rotates=1
		proc/setSpeed(new_speed)
			speed = new_speed
			getVelocity()

		proc/getVelocity()
			vel_x = -cos(angle + 90) * speed
			vel_y = sin(angle + 90) * speed

		proc/wall_hit()
			del src



		proc/trail(t=10)
			var obj/o = new
		//	o.SetCenter(Cx(), Cy(), z)
			o.icon = icon
			o.z = z
			o.y = y
			o.x = x
			o.step_x = step_x
			o.step_y = step_y
			o.icon_state = icon_state
			o.blend_mode = trail_blend
			o.color = color
			o.pixel_y = pixel_y
			o.pixel_x = pixel_x

			var matrix/b = new
			b.Scale(1.5,1.5)
			b.Turn(vangle ? vangle : angle)

			o.transform = b
			o.appearance = appearance
			o.blend_mode = BLEND_ADD
			animate(o, alpha = 0, time = t)
			o.spawndel(t)

		var/trail_blend = BLEND_ADD

		var/dtype="magic"
		bound_x = 4
		bound_y = 4
		void
			icon = 'effects.dmi'
			pewt_state = "void boom"
			icon_state = "void missile"
			dtype = "magic"
			pixel_y = 2
			light_fix=1


			only_players = TRUE
			time = 12
			speed=16
			trail_blend = BLEND_MULTIPLY
			luminosity2=1

			damage = 1
			pewt = 2


			Translate(xx,yy)
				trail(2)
				..(xx/2,yy/2)
				trail(2)
				..(xx/2,yy/2)
				trails++
			trail()
				if(trails > 2)
					..()
			var/trails=0
			pewt()
				..()
				pewt_blend = BLEND_ADD
				layer = layer+1
				pewt=1
				..()
			onHit(mob/player/M)
				if(!M.dead)

					var/R = -kget_angle(src,M)+90
					M.slice()
					M.sparks(null,R)
					M.arcslice(null,R)
					M.sparks("blood spark",R)
					M.blood(null,R)
					..()

			getDamage()
				return 1

		magic2

			icon = 'effects.dmi'
			pewt_state = "magic boom"
			icon_state = "magic missile"
			dtype = "magic"
			pixel_y = 2
			light_fix=1


			only_players = TRUE
			time = 12
			speed=4
			luminosity2=1

			damage = 1
			pewt = 2


			Translate(xx,yy)
				trail(2)
				..(xx/2,yy/2)
				trail(2)
				..(xx/2,yy/2)
				trails++
			trail()
				if(trails > 2)
					..()
			var/trails=0
			pewt()
				..()
				pewt_blend = BLEND_ADD
				layer = layer+1
				pewt=1
				..()
			onHit(mob/player/M)
				if(!M.dead)
					var/R = -kget_angle(src,M)+90
					M.slice()
					M.sparks(null,R)
					M.arcslice(null,R)
					M.sparks("blood spark",R)
					M.blood(null,R)
					..()

			getDamage()
				return 1
		god
			icon = 'effects.dmi'
			pewt_state = "god boom"
			icon_state = "god missile"
			dtype = "magic"
			color= "red"
			pixel_y = 2
			light_fix=1


			only_players = TRUE
			time = 4
			speed=8
			bound_x=0
			bound_y=0
			bound_width=8
			bound_height=8
			luminosity2=1
			pewt_time=10
			pewt_dist=8


			damage = 1
			pewt = 2


			Translate(xx,yy)
				trail(2)
				..(xx/2,yy/2)
				trail(2)
				..(xx/2,yy/2)
				trails++

			trail()
			//	f(trails > 2)
				..()
			var/trails=0
			pewt()
				..()
				pewt_blend = BLEND_ADD
				layer = layer+1
				pewt=1
				..()
			onHit(mob/player/M)
				if(!M.dead)

					var/R = -kget_angle(src,M)+90
					M.slice()
					M.sparks(null,R)
					M.arcslice(null,R)
					M.sparks("blood spark",R)
					M.blood(null,R)
					..()

			getDamage()
				return 1
		magic
			icon = 'effects.dmi'
			pewt_state = "magic boom"
			icon_state = "magic missile"
			dtype = "magic"
			pixel_y = 2
			light_fix=1


			only_players = TRUE
			time = 4
			speed=8
			bound_x=0
			bound_y=0
			bound_width=8
			bound_height=8
			luminosity2=1
			pewt_time=10
			pewt_dist=8


			damage = 1
			pewt = 2


			Translate(xx,yy)
				trail(2)
				..(xx/2,yy/2)
				trail(2)
				..(xx/2,yy/2)
				trails++

			trail()
			//	f(trails > 2)
				..()
			var/trails=0
			pewt()
				..()
				pewt_blend = BLEND_ADD
				layer = layer+1
				pewt=1
				..()
			onHit(mob/player/M)
				if(!M.dead)
					var/R = -kget_angle(src,M)+90
					M.slice()
					M.sparks(null,R)
					M.arcslice(null,R)
					M.sparks("blood spark",R)
					M.blood(null,R)
					..()

			getDamage()
				return 1



mob/player
	var/tmp/doing=0
	var/tmp/wave=0