atom/movable
	var
		pewt_state
		pewt_blend
		pewt_color
		pewt_layer
		pewt_dist
		pewt_time
		pewt_alpha
		pewt=1
		pewtx=0
		pewty=0
		pewt_plane=0
		pewt_bounce=1
		pewt_amount=5
	proc
		dust(a)

			var/obj/O = new/obj
			O.x = x
			O.y = y
			O.z = z
			O.layer = OBJ_LAYER + 0.1
			O.step_x = step_x+bound_x + (bound_width/2) - 5
			O.step_y = step_y+bound_y + (bound_height/2) - 6

			O.icon = 'effects.dmi'
			flick("dust",O)
			var/matrix/M = turn(matrix(),rand(1,360))
			O.transform = M
			var/X=0
			var/Y=0
			if(a)
				X = cos(a)*16
				Y = sin(a)*16
			animate(O,transform = M*0.1,pixel_x = X,pixel_y = Y,alpha=0,time=4)
			O.spawndel(5)
	proc/pewt()
		for(var/i in 1 to pewt_amount)
			var angle = rand(360)

			var obj/o = new
			o.SetCenter(Cx()+pewtx, Cy()+pewty, z)
			o.icon = icon
			o.color = pewt_color ? pewt_color : color
			o.layer = pewt_layer ? pewt_layer : layer

			o.layer = layer+0.01
			o.icon_state = pewt_state ? pewt_state : icon_state
			o.pixel_y = pixel_y
			o.pixel_x = pixel_x
			o.blend_mode = pewt_blend ? pewt_blend : blend_mode
			o.plane = pewt_plane

			var matrix/a = new
			a.Scale(pewt/2)
			a.Turn(angle)

			var matrix/b = new
			b.Scale(pewt/2)
			b.Translate(0, pewt_dist ? pewt_dist : 20)
			b.Turn(angle)

			o.transform = a
			o.alpha = pewt_alpha ? pewt_alpha : 255

			if(pewt_bounce)
				var/R = rand(6,16)
				o.pixel_y = R/2
				spawn(world.tick_lag)
					o.pixel_y = R
					animate(o,pixel_y = -4,easing = BOUNCE_EASING,time = pewt_time ? pewt_time : 3,flags = ANIMATION_PARALLEL)

			animate(o,transform = b, alpha = 0, time = pewt_time ? pewt_time : 3)

			o.spawndel(pewt_time ? pewt_time : 3)