
atom/movable
	var/o_transform
	var/shake_amount=1
	proc
		traily(n,b)
			var/obj/O = new/obj
			O.layer = layer- 0.01
			O.bounds = bounds
			O.SetCenter(Cx(),Cy(),z)
			O.icon = icon
			O.transform = transform
			O.icon_state = icon_state
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y
			if(b)
				O.blend_mode = b

			//O.blend_mode = BLEND_ADD

			animate(O,alpha=0,color = rgb(120,120,120),time = n)
			O.spawndel(n)

		footstep(n=5,i="idle")

			var/obj/O = new/obj
			O.layer = layer- 0.01
			O.bounds = bounds
			O.SetCenter(Cx(),Cy(),z)
			O.icon = 'effects.dmi'
			O.transform = transform
			O.icon_state = i
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			//O.blend_mode = BLEND_ADD

			animate(O,alpha=0,color = rgb(120,120,120),time = n)
			O.spawndel(n)
		dash_dust(n=5)

			var/obj/O = new/obj
			O.layer = layer- 0.01

			O.SetCenter(Cx()-24,Cy(),z)
			O.icon = 'effects.dmi'

			O.transform = transform
			O.icon_state = ""
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			flick("dash dust",O)
			O.spawndel(n)
		jump_dust(n=5)

			var/obj/O = new/obj
			O.layer = layer- 0.01

			O.SetCenter(Cx()-24,Cy(),z)
			O.icon = 'effects.dmi'

			O.transform = transform
			O.icon_state = ""
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			flick("jump dust",O)
			O.spawndel(n)
		land_dust(n=5)

			var/obj/O = new/obj
			O.layer = layer- 0.01

			O.SetCenter(Cx()-24,Cy(),z)
			O.icon = 'effects.dmi'

			O.transform = transform
			O.icon_state = ""
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			flick("land dust",O)
			O.spawndel(n)
		djump_dust(n=5)

			var/obj/O = new/obj
			O.layer = layer- 0.01

			O.SetCenter(Cx()-24,Cy()-16,z)
			O.icon = 'effects.dmi'

			O.transform = transform
			O.icon_state = ""
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			flick("djump dust",O)
			O.spawndel(n)
		slicey(n=5)

			var/obj/O = new/obj
			O.layer = layer- 0.01

			O.SetCenter(Cx()-24,Cy()-16,z)
			O.icon = 'effects.dmi'

			O.transform = transform
			O.icon_state = ""
			O.dir = dir
			O.pixel_x = pixel_x
			O.pixel_y = pixel_y

			O.icon_state = pick("twack")
			O.color = rgb(rand(50,255),rand(50,255),rand(50,255))
			var/matrix/M = matrix()
			M.Turn(rand(1,360))
			animate(O,transform = M,alpha=0,time=n)

			O.spawndel(n)


		shake()

			var/matrix/M = matrix()
			if(o_transform)
				M = matrix(o_transform)

			animate(src,transform = turn(M*(rand(8,12)*0.1),rand(-5,5)*shake_amount),pixel_y = rand(-3,3)*shake_amount,pixel_x = rand(-3,3)*shake_amount,time=1)
			animate(transform = turn(M*(rand(8,12)*0.1),rand(-5,5)*shake_amount),pixel_y = rand(-3,3)*shake_amount,pixel_x = rand(-3,3)*shake_amount,time=1)
			animate(transform = M,pixel_y=0,pixel_x=0,time=1)

		slice(i,n=1,c=null)

			var/obj/O = new/obj()
			O.x=x
			O.y=y
			O.z=z

			O.step_x = step_x + bound_x + (bound_width/2) - 8
			O.step_y = step_y + bound_y + (bound_height/2) - 2

			O.icon = 'effects.dmi'

			flick(i ? i : "slice",O)
			var/matrix/M = matrix()
			O.layer = layer+1
		//	O.plane = 2

			M.Scale(n * (rand(10,20) * 0.1))
			M.Turn(rand(1,360))
			O.transform = M
			if(c)
				O.color = c

			O.blend_mode = BLEND_ADD

			spawn(2)
				animate(O,alpha=0,time=5)
			O.spawndel(7)

		arcslice(i,a,n=1,c=null)

			var/obj/O = new/obj()
			O.x=x
			O.y=y
			O.z=z

			O.step_x = step_x + bound_x + (bound_width/2) - 8
			O.step_y = step_y + bound_y + (bound_height/2) - 2

			O.icon = 'effects.dmi'

			flick(i ? i : "arc",O)
			var/matrix/M = matrix()
			O.layer = layer+1
		//	O.plane = 2

			M.Scale(n * (rand(10,20) * 0.1))
			if(!a)
				a = rand(1,360)
			else
				a = a + rand(-10,10)

			M.Turn(a)
			O.transform = M
			if(c)
				O.color = c

			O.blend_mode = BLEND_ADD


			var/D = rand(8,16)

			animate(O,pixel_y = sin(-a+90)*D,pixel_x = cos(-a+90)*D,alpha=0,time=5)
			O.spawndel(7)

		sparks(i,a,n=1,c=null)
			for(var/i3=0,i3<rand(4,8),i3++)
				var/obj/O = new/obj()
				O.x=x
				O.y=y
				O.z=z

				O.step_x = step_x + bound_x + (bound_width/2) - 8
				O.step_y = step_y + bound_y + (bound_height/2) - 2

				O.icon = 'effects.dmi'

				flick(i ? i : "sparks",O)
				var/matrix/M = matrix()
				O.layer = layer+1
			//	O.plane = 2

				M.Scale(n * (rand(10,20) * 0.1))
				M.Turn(rand(1,360))
				O.transform = M
				if(c)
					O.color = c

				O.blend_mode = BLEND_ADD
				var/A = rand(1,360)
				if(a)
					A = a + rand(-20,20)

				animate(O,pixel_y = sin((-A)+90)*rand(4,8),pixel_x = cos((-A)+90)*rand(4,8),alpha=0,time=3)

				O.spawndel(5)


		blood(i,a,n=1,c=null)
			for(var/i3=0,i3<rand(8,16),i3++)
				var/obj/O = new/obj()
				O.x=x
				O.y=y
				O.z=z

				O.step_x = step_x + bound_x + (bound_width/2) - 8
				O.step_y = step_y + bound_y + (bound_height/2) - 2

				O.icon = 'effects.dmi'

				O.icon_state = i ? i : "blood"
				var/matrix/M = matrix()
				O.layer = OBJ_LAYER + 0.01

				M.Turn(rand(1,360))
				var/R = (n * (rand(5,15) * 0.1))
				M.Scale(R,R*0.75)
				O.transform = matrix()*0.1
				if(c)
					O.color = c
				if(!i)
					O.blend_mode = BLEND_MULTIPLY

				var/A = rand(1,360)
				if(a)
					A = a + rand(-20,20)

				var/PY = rand(16,48)
				var/PX = rand(16,48)

				animate(O,transform = M,pixel_y = sin((-A)+90)*(PY/2),pixel_x = cos((-A)+90)*(PX/2),pixel_z = rand(8,16),time=2)
				animate(pixel_y = O.pixel_y+(sin((-A)+90)*(PY/2)),pixel_x = O.pixel_x + (cos((-A)+90)*(PX/2)),pixel_z=0,time=2)
				animate(transform = O.transform*2,time=10)
				animate(transform = O.transform*1.1,time=20)
				animate(transform = O.transform*1.1,alpha=0,time=20)

				O.spawndel(80)