hud
	dialogue_bg
		icon = 'turfs.dmi'
		icon_state = "black"
		sx=1
		sy=1
		alpha = 150


		set_pos(client/C)
			screen_loc = "CENTER,SOUTH+7"
			viewResized(C)

		viewResized(client/C)
			transform=matrix(C.view_width+2,8,MATRIX_SCALE)


	dialogue

	//	icon = 'dialogue box.dmi'
	//	icon_state = ""
		sx="WEST"
		sy="SOUTH"

	//	color = "black"
		layer = 1002
		alpha=225
		standing=0

		var
			obj/me
			obj/ti

			obj/o1
			obj/o2
			obj/o3

			obj/port

			message
			title

			writing=0

		var/option
		var/options = list()
		hide()
			..()
			mob_owner.hideHud("dialogue bg")
		show()
			..()
			mob_owner.showHud("dialogue bg")
			mob_owner.hideHud("grid manager")


		New()
			..()
			var/matrix/M = matrix()
			M.Scale(6,1)
			transform = M
			me = new/obj
			me.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR

			me.pixel_x = 16
			me.pixel_y = 10
			me.maptext_width = 320
			me.maptext_height = 70
			me.maptext_x = 0
			me.maptext_y = 8
			me.plane = plane
			overlays += me
			me.layer = 1003

			ti = new/obj
			ti.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR

			ti.pixel_x = 16
			ti.pixel_y = 90
			ti.maptext_width = 160
			ti.maptext_height = 60
			ti.plane = plane
			overlays += ti
			ti.layer = 1003

			o1 = new/obj
			o1.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR

			o1.pixel_x = 230
			o1.pixel_y = 90
			o1.maptext_width = 160
			o1.maptext_height = 60
			o1.plane = plane
			overlays += o1
			o1.layer = 1003

			o2 = new/obj
			o2.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR
			o2.pixel_x = 300
			o2.pixel_y = 90
			o2.maptext_width = 160
			o2.plane = plane
			o2.maptext_height = 60
			overlays += o2
			o2.layer = 1003

			o3 = new/obj
			o3.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR

			o3.pixel_x = 370
			o3.pixel_y = 90
			o3.maptext_width = 160
			o3.maptext_height = 60
			o3.plane = plane
			overlays += o3
			o3.layer = 1003

			port = new/obj
			port.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR

			port.pixel_x = 370
			port.pixel_y = 100

			port.plane = plane
			overlays += port
			port.layer = 1003
		//	port.icon = 'portraits.dmi'

		update()
			..()
			var/mob/owner = mob_owner
			if(message || title)

				show()

				overlays -= ti
				ti.maptext = "<b>[title]"
				overlays += ti

				overlays -= port
				port.icon_state = "[title]"
				overlays += port


				if(writing == 0)


					writing = lentext(message)

				overlays -= me

				if(writing != -1)
					writing-=2
					if(writing > 0)

						me.maptext = copytext(message,1,length(message)-writing)
				//		owner:playSound('boop.wav')
				//		owner.gs('chat blip.wav')

				if(writing == 0)

					writing = -1
					me.maptext = message

				else
					if(writing != -1)
						spawn(world.tick_lag)

							if((message || title) && writing > 0)
								update()

				if(writing == -1)
					me.maptext = message
				me.maptext = "<p valign = top>[me.maptext]"
				me.appearance_flags = RESET_TRANSFORM | RESET_ALPHA | RESET_COLOR
				overlays += me

				overlays -= o1
				overlays -= o2
				overlays -= o3
				o1.maptext = ""
				o2.maptext = ""
				o3.maptext = ""
				if(length(options) > 0)

					o1.maptext = options[1]

					if(option == null)
						option = options[1]

					if(option == 1)
						o1.maptext = "<b>[o1.maptext]"
					else
						o1.maptext = "[o1.maptext]"

				if(length(options) > 1)

					o2.maptext = options[2]
					if(option == 2)
						o2.maptext = "<b>[o2.maptext]"
					else
						o2.maptext = "[o2.maptext]"
				if(length(options) > 2)

					o3.maptext = options[3]
					if(option == 3)
						o3.maptext = "<b>[o3.maptext]"
					else
						o3.maptext = "[o3.maptext]"
				overlays += o1
				overlays += o2
				overlays += o3

				if(owner)

					owner.in_dialogue=1

			else
				hide()
				writing = 0



mob
	var
		tmp/in_dialogue=0
		tmp/can_dstep=1
	proc
		dialogue_click()
			if(in_dialogue)
	//			playSound('InventoryClick.wav')
				for(var/hud/dialogue/O in client.screen)
					if(O.writing > 0 && O.writing != -1)
						O.writing=-1
						O:update()
						return
					else
						O.message = null
						O.title = null
						src:updateHud("dialogue")
						return
		convo(c)
			var/t = text2path("/conversation/[c]")
			var/conversation/co = new t
			co.read(src)

		dalert(message,title,options=list())

		//	world << "test"
			for(var/hud/dialogue/O in client.screen)

				O.message = message
				O.title = title
				O.options = options
				O.option=1
			//	O.writing=-

				src:updateHud("dialogue")
				if(src:showingHud("grid manager"))
					src:toggleHud("grid manager")


				while(O.message)

					sleep(world.tick_lag)

			//	for(var/g in O.options)
			//		world << g

				if(length(O.options))
			//		world << "test"
					var/V = O.options
					O.options = list()
				//	world << V[O.option]

					return V[O.option]

		dialogue_step(d)

			if(can_dstep)
				can_dstep=0
				spawn(3)
					can_dstep=1
			else
				return
			for(var/hud/dialogue/O in client.screen)

				if(d == EAST)

					O.option++

			//		world << "test"
					if(O.option == length(O.options)+1)
						O.option = 1
					//	world << "hi"
			//		world << O.option

				if(d == WEST)
					O.option--

					if(O.option == 0)
						O.option = length(O.options)
				break
			src:updateHud("dialogue")
