mob
	var/tmp/obj/follow_light
light
	parent_type = /obj
	var
		tmp/light_range = 10
		tmp/light_intensity=200
		tmp/light_color_r=255
		tmp/light_color_g=255
		tmp/light_color_b=0

	appearance_flags = 0

	red
		light_range = 5
		light_intensity=100
		light_color_r=255
		light_color_g=0
		light_color_b=0
	blue
		light_range = 5
		light_intensity=100
		light_color_r=0
		light_color_g=0
		light_color_b=255
	purple
		light_range = 5
		light_intensity=100
		light_color_r=255
		light_color_g=0
		light_color_b=255
	little_blue
		light_range = 3
		light_intensity=100
		light_color_r=0
		light_color_g=0
		light_color_b=255
	sky
		light_range = 15
		light_intensity=200
		light_color_r=0
		light_color_g=255
		light_color_b=255
	biglight
		light_range = 20
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
	biggerlight
		light_range = 40
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
	softlightnoise
		light_range = 3
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
		light_icon_state = "noise"

	godraybig
		light_range = 6
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
		light_icon_state = "god ray"
	godray
		light_range = 3
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
		light_icon_state = "god ray"
	godray2
		light_range = 5
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
		light_icon_state = "god ray 2"

	godray3
		light_range = 10
		light_color_r = 200
		light_color_g = 200
		light_color_b = 255
		light_icon_state = "god ray 2"

	noisey
		light_range = 6
		light_color_r = 200
		light_color_g = 200
		light_color_b = 255
		light_icon_state = "noise light"
	doorway
		light_range = 3
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
		light_icon_state = "doorway"


	softlight
		light_range = 12
		light_color_r = 255
		light_color_g = 255
		light_color_b = 255
	softredtouch
		light_range = 12
		light_color_r = 200
		light_color_g = 200
		light_color_b = 20
	softbluetouch
		light_range = 12
		light_color_r = 0
		light_color_g = 200
		light_color_b = 200
	softpurpletouch
		light_range = 12
		light_color_r = 200
		light_color_g = 0
		light_color_b = 200
	ominousblue
		light_range = 15
		light_color_r = 0
		light_color_g = 100
		light_color_b = 255

	ominousred
		light_range = 15
		light_color_r = 255
		light_color_g = 100
		light_color_b = 0
	bluesky
		light_range = 15
		light_intensity=200
		light_color_r=0
		light_color_g=100
		light_color_b=255
	green2
		light_range = 7
		light_intensity=100
		light_color_r=0
		light_color_g=255
		light_color_b=0
	softgreen
		light_range = 12
		light_intensity=100
		light_color_r=20
		light_color_g=200
		light_color_b=20
	green
		light_range = 5
		light_intensity=100
		light_color_r=0
		light_color_g=255
		light_color_b=0
	orange
		light_range = 5
		light_intensity=255
		light_color_r=255
		light_color_g=100
		light_color_b=0
	yellow
		light_range = 5
		light_intensity=255
		light_color_r=255
		light_color_g=255
		light_color_b=0
	alpha=100
	New(location,re_light=0)
		..()
		icon = null
		alpha=255
		lightup()

	icon = 'turfs.dmi'
	icon_state = "darkness"

	proc/lightoff()
		setLum(0)

	proc/lightup()
	//	if(light_range < 15)
		//	appearance_flags = TILE_BOUND

		setLum(light_range,rgb(light_color_r,light_color_g,light_color_b))

turf
	var/light_amount = 220
	var
		light_color_r
		light_color_g
		light_color_b
		light
		tile_color
		tile_alpha


var/area/abv

atom/var/luminosity2=0

atom/movable/var/light_fix=0
atom/movable/var/light_icon_state = ""
atom/movable/var/claimed=0

atom/movable/proc
	setLum(n,c)
		if(newlight)
			overlays -= newlight
		var/matrix/m = matrix()
		m.Scale(n/3)
		luminosity2=n
		if(!newlight)
			newlight = new()
			newlight.icon_state = light_icon_state
			newlight.alpha = 150

		if(!ismob(src) && !claimed)
			claimed=1
			for(var/turf/T in orange(luminosity2,src))
				if(!T.lights)
					T.lights = list()

				T.lights += src


		if(newlight)
			newlight.transform = m

			if(luminosity2==1 && bound_width==8 && bound_height==8 && light_fix==0)
				newlight.pixel_x = -28
				newlight.pixel_y = -28
			if(ismob(src))
				newlight.pixel_x = bound_x/2 - bound_width*2
				newlight.pixel_y = bound_y/2 - bound_height*2
		if(c)
			light_color = c

		newlight.color = light_color
		overlays += newlight

atom/var/light_color

turf
	var/lights
image
	plane3
		plane=3
	plane4
		plane=4
var/obj/back/backobj = new
var/obj/darkness/darknessobj = new
var/obj/lighting_plane/lighting_plane = new

obj/lighting_plane
    screen_loc = "CENTER,CENTER"
    plane = 2
    blend_mode = BLEND_MULTIPLY
    appearance_flags = PLANE_MASTER | NO_CLIENT_COLOR
    mouse_opacity = 0

obj
	opaque
		opacity=1
		invisibility=1
		layer = MOB_LAYER+10
		icon = 'turfs.dmi'
		icon_state = "darkness"
		color = "#ff00ff"
		alpha=100

	dense
		density=1
		invisibility=1
		layer = MOB_LAYER+10
		icon = 'turfs.dmi'
		icon_state = "darkness"
		color = "red"
		alpha=100
	darkness
		screen_loc = "SOUTH,WEST to NORTH,EAST"
		plane = 2
		blend_mode = BLEND_ADD
		mouse_opacity = 0
		icon = 'turfs.dmi'
		color = "black"
		icon_state = "darkness"
		appearance_flags = 0
		New()
			..()
			color = rgb(34,32,52)
	back
		screen_loc = "SOUTH,WEST to NORTH,EAST"
		plane = -2

		mouse_opacity = 1
		icon = 'turfs.dmi'
		icon_state = "back"
		appearance_flags = 0
		color = "black"
		blend_mode = BLEND_SUBTRACT
color_area
	parent_type = /obj

	red
	blue
	yellow
	green
	orange
	purple
	black
	white
	brownyellow
		color = "#69732A"
	New()
		..()
		if(!color)
			color = name
	/*Cross(mob/player/M)
		if(M.client)
			var/obj/O = backobj
			if(O)
				animate(O,color =color,time = 10)
		return 1*/
image
	light
		plane = 2
		blend_mode = BLEND_ADD
		icon = 'light.dmi'
		mouse_opacity = 0
		pixel_x = -28
		pixel_y = -28
		appearance_flags = RESET_TRANSFORM | RESET_ALPHA | KEEP_APART


atom
	var/tmp/image/light/newlight
mob
	var
		tmp/image
			darkness

atom/movable
	New()
		..()
		if(luminosity2)
			setLum(luminosity2)